//Kristen Kleckner - Capstone 2015
//Last Modified May 10, 2015

#ifndef TWEETINFO_H
#define TWEETINFO_H

#include <iostream>
using namespace std;

const int DEFAULT_COUNT = -1;
const int DEFAULT_LOCATION  = -1;

class TweetInfo
{
public:
	/*********** Constructors and Destructors ************/
	TweetInfo();
	TweetInfo(int l, int c);
	TweetInfo(const TweetInfo & orig);
	TweetInfo & operator=(const TweetInfo & right);
	~TweetInfo();

	/*********** Accessors and Mutators ***********/
	int GetLocation() const;
	int GetCount() const;
	void Display(ostream & out) const;

private:
	int count;		//number of retweets or favorites
	int location;	//the line number of the tweet

};

ostream & operator << (ostream & out, const TweetInfo & tweet);
bool operator > (const TweetInfo & left, const TweetInfo & right);

#endif

TweetInfo::TweetInfo()
{
	//Default constructor
	count = DEFAULT_COUNT;
	location = DEFAULT_LOCATION;
}

TweetInfo::TweetInfo(int l, int c)
{
	//constructor to set values based on input
	count = c;
	location = l;
}

TweetInfo::TweetInfo(const TweetInfo & orig)
{
	//copy constructor
	count = orig.count;
	location = orig.location;
}

TweetInfo & TweetInfo::operator=(const TweetInfo & right)
{
	//assignment operator
	count = right.count;
	location = right.location;
	return *this;
}

TweetInfo::~TweetInfo()
{
	count = DEFAULT_COUNT;
	location = DEFAULT_LOCATION;
}

int TweetInfo::GetLocation() const
{
	return location;
}

int TweetInfo::GetCount() const
{
	return count;
}


void TweetInfo::Display(ostream & out) const
{
	//outputs as location, count ordered pair
	out << location << "," << count;
}

//overloaded less than operator
bool operator >(const TweetInfo & left, const TweetInfo & right)
{
	if(left.GetCount() > right.GetCount())
		return true;
	else
		return false;
}

//overloaded output operator
ostream & operator << (ostream & out, const TweetInfo & t)
{
	t.Display(out);
	return out;
}